// -*- coding: utf-8 -*-
/* (C) vniitf, ignatiev
  Библиотека функций для хранения многомерных массивов
  и доступа к ним.
  Внимание: все экстенты должны быть по catrlen
  обшая длина каталога catmlen*(nexts+1) >= catrlen
*/
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <sys/types.h>

# include "sio2.h"
# include "sio_msg.h"

#ifndef max
#define max(a,b) ((a) > (b) ? (a) : (b))
#define min(a,b) ((a) < (b) ? (a) : (b))
#endif

void mistake (int,char*);
int  pack (HF*);
void Swap();
int read_hcat(HCAT*, HF*);
int read_mcat(MCAT*, HF*);
int read_hcat2(HCAT*, HF*);
int read_mcat2(MCAT*, HF*);
int write_hcat(HCAT*, HF*);
int write_mcat(MCAT*, HF*);
int write_hcat2(HCAT*, HF*);
int write_mcat2(MCAT*, HF*);
void text_f2c(char*, int, char*, int);
int FindInCat(MCAT*,int,const char*,int,int, int);
int InsertInCat(HF**, const char*, int, size_t, int);

size_t Fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
/* чтение пока все не прочитано, для Windows */
{
  size_t lr, rest = nmemb, full = 0;
  char* p = (char*)ptr;
  while (lr = fread(p, size, rest, stream) > 0) {
    p += lr*nmemb;
    full += lr*nmemb;
    rest -= lr*nmemb;
    //printf("-read: size=%zd full=%zd rest=%zd lr=%zd nmemb=%zd\n", size, full, rest, lr, nmemb);
  }
  //printf("Fread: size=%zd full=%zd rest=%zd\n", size, full, rest);
  return full;
}

static char msg[80];
static char msgext[40];
const char *empty_name = "                       ";
//static int  trunc;      /* что делать если буфер < записи: 1 - обрезать буфер, 0 - выдавать ошибку */


/* ============================================================== SIOFOP = */
int siofop (const char* filename   /* имя фaйлa                                  */
	    ,int   cputype_  /* фopmaт xpaнeния дaнныx - не используется   */
	    ,int   status    /* cтaтyc фaйлa (нов/cтap/люб)                */
	    ,int   lcat      /* длинa катaлoгa                             */
	    ,int   delkey_   /* ключ yничтoжeния - не используется         */
	    ,HF**  hfp       /* дecкpиптop фaйлa                           */
	    )
{
  int  f, fs, i;
  int lcatt;
  MCAT* cat;
  HCAT* hcat;
  HF* hf = *hfp;
  int ko;
# if __BYTE_ORDER == __LITTLE_ENDIAN
  // ничего делаь не надо
# else
  -*- __BIG_ENDIAN not realized -*-
# endif
  //  printf ("sizeof(cat_s)=%d %d\n", sizeof(cat_s), sizeof(struct cat));
  strncpy (msgext,filename,39); msgext[39]=0;

  hf = (HF*)malloc(sizeof(HF));
  *hfp = hf;
  //printf("@@ siofop hf=%p sizeof=%zd\n", hf, sizeof(HF));
  if (hf == NULL) { ko = MSNOMEM; mistake(ko,m2); return ko; }
  hf->trunc = 0;

  if ((hf->filptr = fopen(filename,"rb")) == NULL) fs = STNEW;
  else                                            fs = STOLD;
  if (fs == STOLD) fclose(hf->filptr);

  hf->modpr = 0;
  if ((status == STOLD || status == STRO) && fs == STNEW) {
    ko = MSFOP2; mistake(ko ,m3); return ko;
  }
  else if (status == STNEW || status == STUNK && fs == STNEW) {
    if ((hf->filptr = fopen(filename,"wb+")) == NULL) {
      ko =MSFOP1; mistake(ko,m4); return ko;
    }
  }
  else if (status == STRO) {
    if ((hf->filptr = fopen(filename,"rb")) == NULL) {
      ko =MSFOP1; mistake(ko,m4); return ko;
    }
  }
  else {
    if ((hf->filptr = fopen(filename,"rb+")) == NULL) {
      ko =MSFOP1; mistake(ko,m5); return ko;
    }
  }

  if (fs == STNEW || status == STNEW) {    /* new file */
    lcatt = (size_t)(lcat==0 ? 100 : lcat);
    //printf("## siofop NEW lcatt=%d\n", lcatt);

    cat = (MCAT*)malloc(sizeof(CAT)*lcatt);
    /* memset(&((*cat)[0]),0x00,sizeof(CAT)*lcatt); Это не надо! */
    if (cat == NULL) {
      printf("@@ siofop cat=%p sizeof=%zd lcatt=%d\n",
	     cat, sizeof(CAT), lcatt);
      ko = MSNOMEM; mistake(ko,m6);
      return ko;
    }
    memset(&((*cat)[0]),0x00,sizeof(CAT)*lcatt);

    hcat = (HCAT*)malloc(sizeof(HCAT));
    /* memset(hcat,0x00,sizeof(HCAT)); Это не надо!*/
    if (hcat == NULL) {
      printf("@@ siofop hcat=%p sizeof=%zd\n",
	     hcat, sizeof(HCAT));
      ko = MSNOMEM; mistake(ko,m6);
      return ko;
    }
    memset(hcat,0x00,sizeof(HCAT));

    hf->ver2 = 1;
    //printf("New Version\n");
    hcat->catver2='2';
    hcat->catmlen=lcatt;
/*     hcat->catdelkey=delkey; */
    hcat->catfaddr = hf->faddr = 16 +lcatt*sizeof(struct cat);
    //    printf("siofop, faddr=%ld lcatt=%d\n", hf->faddr, lcatt);
    hcat->nexts = 0;
    hf->catptr = cat;
    hf->hcatptr = hcat;
    hf->modpr  =1;
    hf->lencat =0;
    hf->cpol   =0;
  }
  else {                                 /* old file */
    hcat = (HCAT*)malloc(sizeof(HCAT));
    if (hcat == NULL) {
      printf("@@ siofop hcat=%p sizeof=%zd\n",
	     hcat, sizeof(HCAT));
      ko = MSNOMEM; mistake(ko,m6);
      return ko;
    }
    ko = read_hcat(hcat, hf); if (ko) return ko;
    //printf("## siofop OLD lcatt=%d\n", hcat->catmlen);
    if (hcat->catver2 == '2') {
      hf->ver2 = 1;
      //printf("New Format\n");
    } else {
      hf->ver2 = 0;
      printf("Old Format\n");	/* может, вобще убрать поддержку старой версии? */
    }
    lcatt = sizeof(CAT)*(hcat->catmlen * (hcat->nexts+1));
/*     printf("### siofop lcatt=%d catrlen=%d catmlen=%d nexts=%d\n", */
/*            lcatt, hcat->catrlen, hcat->catmlen, (hcat->nexts+1)); */
    cat = (MCAT*)malloc(lcatt);
    if (cat == NULL) {
      //printf("@@ siofop cat=%p sizeof=%zd lcatt=%d\n",
      //	     cat, sizeof(HCAT), lcatt);
      ko = MSNOMEM; mistake(ko,m6);
      return ko;
    }
    hf->catptr = cat;
    hf->hcatptr = hcat;
    if (hf->ver2) {
      ko = read_mcat2(cat, hf);  if (ko) return ko;
    } else {
      ko = read_mcat(cat, hf);  if (ko) return ko;
    }
/*     if (hcat->catdelkey != delkey) { */
/*       ko=MSFOP5; mistake(ko,m9); return ko; */
/*     } */
    hf->catptr=cat;
    hf->hcatptr=hcat;
    hf->lencat=hcat->catrlen;
    hf->faddr =hcat->catfaddr;
    //    printf("siofop, faddr=%ld\n", hf->faddr);
    hf->cpol  =0;
/*     printf("siofop, hf=%ld\n", hf); */
/*     printf("siofop, lencat=%d\n", hf->lencat); */
  }
  return 0;
} /* siofop */



/* ============================================================== SIOFCL = */
int siofcl (HF* hf       /* дескриптор файла         */
           ,int packpr    /* признак уплотнения файла */
           )
{
  int lcatt, i;
  MCAT* cat;
  HCAT* hcat;
  int ko;
  char date[20], *pd;
  int m = 0, d = 0, y = 0;

  //  printf("siofcl hf->filptr=%p ver=%d\n", hf->filptr, hf->ver2);
  //printf("siocfl faddr = %d modpr=%d\n", hf->faddr, hf->modpr);
  strcpy (date,__DATE__);
  pd = strchr(date,' ');
  if (pd != NULL) {
    date[pd-date] = 0x00; pd++;
    if      (strncmp(date,"Jan",3) == 0) m = 1;
    else if (strncmp(date,"Feb",3) == 0) m = 2;
    else if (strncmp(date,"Mar",3) == 0) m = 3;
    else if (strncmp(date,"Apr",3) == 0) m = 4;
    else if (strncmp(date,"May",3) == 0) m = 5;
    else if (strncmp(date,"Jun",3) == 0) m = 6;
    else if (strncmp(date,"Jul",3) == 0) m = 7;
    else if (strncmp(date,"Aug",3) == 0) m = 8;
    else if (strncmp(date,"Sep",3) == 0) m = 9;
    else if (strncmp(date,"Oct",3) == 0) m = 10;
    else if (strncmp(date,"Nov",3) == 0) m = 11;
    else if (strncmp(date,"Dec",3) == 0) m = 12;
    sscanf(pd,"%d %d", &d, &y);
    y = y % 100;
    //printf("@@ date %s: %02x %02x %02x\n", date, y,m,d);
  }
  strcpy (msgext,"");
  if (hf==NULL) {
    ko=MSFCL4;
    mistake(ko,m10);
    return ko;
  }
  cat=hf->catptr;
  hcat=hf->hcatptr;
  hcat->date_y = y;
  hcat->date_m = m;
  hcat->date_d = d;
  if (hf->modpr) {
    mistake(0,"sioclf - cбpoc кaтaлoгa");
    if (fseek(hf->filptr,0,SEEK_SET) != 0) {
      ko=MSFCL1;
      mistake(ko,m11);
      return ko;
    }
    hcat->catrlen=hf->lencat;
    hcat->catfaddr=hf->faddr;
    lcatt=hcat->catmlen*sizeof(CAT);
    if (hf->ver2) {
      ko = write_hcat(hcat, hf); if (ko) return ko;
      ko = write_mcat2(cat, hf);  if (ko) return ko;
    } else {
      ko = write_hcat(hcat, hf); if (ko) return ko;
      ko = write_mcat(cat, hf);  if (ko) return ko;
    }
  }
  if (packpr == 2) {		/* flush - это не закрытие, а только сброс каталогов*/
    if (fflush(hf->filptr) != 0) {
      ko=MSFCL5;
      mistake(ko,m78);
      return ko;
    }
  }
  else {			/* close - это реальное закрытие с освобождением памяти */
    if (fclose(hf->filptr) != 0) {
      ko=MSFCL3;
      mistake(ko,m14);
      return ko;
    }
    free(cat);
    free(hcat);
    free(hf); hf= NULL;
  }
  return 0;
} /* siofcl */


/* ============================================================ SIOFLUSH = */
int sioflush (HF* hf       /* дескриптор файла         */
	      )
{
  return siofcl (hf,2);
} /* sioflush */


/* ============================================================= SIOFCAT = */
int siofcat (HF* hf        /* дecкpиптop фaйлa  */
            ,int  lcat      /* длина вывода      */
            ,char* mcat     /* массив для вывода */
            )
{
  char *pc;
  int ko;
  int lenname = (hf->ver2 ? 23 : 13);
# define OUT					\
  if(lcat == 0) puts(s);			\
  else if (lc < lcat) {				\
    memset(&pc[0],' ',80);                      \
    memcpy(pc,s,strlen(s));			\
    pc[79] = 0x00;				\
    pc += 80; lc++;				\
  }						\
  else {ko = MSFCT2; return ko; }

  MCAT* cat;
  HCAT* hcat;
  int i, lc=0;
  static char *fmt,name[24],s[80];

/*   printf("siofcat, hf=%ld\n", hf); */
/*   printf("siofcat, lencat=%d\n", hf->lencat); */
  strcpy (msgext,"");
  if (hf == NULL) {
    ko=MSFCT1;
    mistake(ko,m15);
    return ko;
  }
  pc = mcat;
  cat=hf->catptr;
  hcat=hf->hcatptr;
  sprintf(s+30," sio: %d %d %d -------", hcat->date_y, hcat->date_m, hcat->date_d); s[48]=0x00;
  OUT;
# ifdef LATONLY
  sprintf(s,"%s"," name                 number   type    length format      address"); OUT;
# else
  sprintf(s,"%s","имя зaпиcи             нoмep    тип     длинa фopмaт        aдpec"); OUT;
# endif
  sprintf(s,"%s","----------------------------+------+----------------+------------"); OUT;
  //printf("siofcat, lencat=%d\n", hf->lencat);
  for (i=0; i<hf->lencat; i++) {
    strncpy(name,(*cat)[i].lctname,lenname); name[lenname]=0x00;
    switch ((*cat)[i].lcttype) {
    case T_RECNAME: 
      if ((*cat)[i].lctnom ==0) {
	switch ((*cat)[i].lctform) {
	case 14: fmt="real*4"; break;
	case 18: fmt="real*8"; break;
	case 21: fmt="int*1 "; break;
	case 22: fmt="int*2 "; break;
	case 24: fmt="int*4 "; break;
	case 28: fmt="int*8 "; break;
	case 31: fmt="char*1"; break;
	default: fmt="      ";
	}
	/* printf("lctlen=%ld lelem=%d lrec=%ld\n",  */
	/*        (*cat)[i].lctlen ,  */
	/*        LENFORMT((*cat)[i].lctform), */
	/*        (*cat)[i].lctlen / LENFORMT((*cat)[i].lctform) */
	/*        ); */
	sprintf(s,"%23s %3s %6s %10zd %6s %12zd"
		,name
		,""
# ifdef LATONLY
		,"record"
# else
		,"зaпиcь"
# endif
		,(*cat)[i].lctlen / LENFORMT((*cat)[i].lctform)
		,fmt
		,(*cat)[i].lctaddr
		);
	OUT;
      }
      else {
	sprintf(s,"%23s %4d%7s%10zd %6s %12zd"
		,name
		,(*cat)[i].lctnom
# ifdef LATONLY
		,"ekz.gr."
# else
		,"экз.гp."
# endif
		,(*cat)[i].lctlen
# ifdef LATONLY
		,"bytes "
# else
		,"бaйт  "
# endif
		,(*cat)[i].lctaddr
		);
	OUT;
      }
      break;
    case T_GRPNAME: 
      sprintf(s,"%23s %4s%7s%10zd %6s %6zd полей%s"
	      ,name
	      ,"    "
# ifdef LATONLY
	      ,"  group"
# else
	      ," группа"
# endif
	      ,(*cat)[i].lctlen
# ifdef LATONLY
	      ,"bytes "
# else
	      ,"байт  "
# endif
	      ,(*cat)[i].lctaddr
# ifdef LATONLY
	      ," flds"
# else
	      ,"       "
# endif
	      );
      OUT;
      break;
    case T_POLNAME: 
      switch ((*cat)[i].lctform) {
      case 14: fmt="real*4"; break;
      case 18: fmt="real*8"; break;
      case 21: fmt="int*1 "; break;
      case 22: fmt="int*2 "; break;
      case 24: fmt="int*4 "; break;
      case 28: fmt="int*8 "; break;
      case 31: fmt="char*1"; break;
      default: fmt="      ";
      }
      sprintf(s,"%23s %4s%7s%10zd %6s %12s"
	      ,name
	      ,"    "
# ifdef LATONLY
	      ,"  field"
# else
	      ,"   поле"
# endif
	      ,(*cat)[i].lctlen / LENFORMT((*cat)[i].lctform)
	      ,fmt
	      ,"        "
	      );
      OUT;
      break;
    case T_ARRDEF:
      switch ((*cat)[i].lctform) {
      case 14: fmt="real*4"; break;
      case 18: fmt="real*8"; break;
      case 21: fmt="int*1 "; break;
      case 22: fmt="int*2 "; break;
      case 24: fmt="int*4 "; break;
      case 28: fmt="int*8 "; break;
      case 31: fmt="char*1"; break;
      default: fmt="      ";
      }
      sprintf(s,"%23s  %2dD %6s %9zd %6s %12zd"
	      ,name
	      ,(*cat)[i].lctnom
# ifdef LATONLY
	      ," array"
# else
	      ,"массив"
# endif
	      ,(*cat)[i].lctlen / LENFORMT((*cat)[i].lctform)
	      ,fmt
	      ,(*cat)[i].lctaddr
	      );
      OUT;
      break;
    case T_ARRDIM:
      switch ((*cat)[i].lctform) {
      case 14: fmt="real*4"; break;
      case 18: fmt="real*8"; break;
      case 21: fmt="int*1 "; break;
      case 22: fmt="int*2 "; break;
      case 24: fmt="int*4 "; break;
      case 28: fmt="int*8 "; break;
      case 31: fmt="char*1"; break;
      default: fmt="      ";
      }
      sprintf(s,"%23s  %3d %6s %9zd %6s %12zd"
	      ,name
	      ,(*cat)[i].lctnom
# ifdef LATONLY
	      ,"  dim"
# else
	      ," измер"
# endif
	      ,(*cat)[i].lctlen / LENFORMT((*cat)[i].lctform)
	      ,fmt
	      ,(*cat)[i].lctaddr
	      );
      OUT;
      break;
      //    case T_ARRBASE:
      //break;
    case T_CATEXT:
      sprintf(s,"%23s %4d%7s%10zd %6s %12zd"
	      ,name
	      ,(*cat)[i].lctnom
# ifdef LATONLY
	      ,"  catal"
# else
	      ,"  катал"
# endif
	      ,(*cat)[i].lctlen
	      ,"      "
	      ,(*cat)[i].lctaddr
	      );
              OUT;
            break;
    default: 
      sprintf(s,"? ? ?"); OUT;
    }
  }
# ifdef LATONLY
  sprintf(s,"Total      :                                         %12zd",hf->faddr); OUT;
# else
  sprintf(s,"Длина файла:                                         %12zd",hf->faddr); OUT;
# endif
  sprintf(s,"%s","----------------------------+------+----------------+------------"); OUT;
  return lc;
} /* siofcat */



/* ============================================================== SIORWR = */
int sioriwr ( HF*  hf       /* дecкpиптop фaйлa     */
            ,const char* namerecp /* имя зaпиcи           */
            ,void* array    /* мaccив oбмeнa        */
            ,int   index    /* смещение по записи   */
            ,int   len      /* eгo длинa            */
            ,int   form     /* фopmaт eгo элemeнтoв */
            )
{
  int lcatt, ind;
  size_t addr, lenb, l, bindex;
  MCAT* cat;
  HCAT* hcat;
  //  char namerec[14],  /* бeз xвocтoвыx пpoбeлoв */
  //       namerecc[14]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  /* printf ("sioriwr name=%s index=%d len=%d form=%d ver=%d\n", namerecp, index, len, form, hf->ver2); */
  sprintf(msgext,"%.13s",namerecp);
  if (!hf->ver2) {
    ko=MSNWR;
    mistake(ko,m79);
    return ko;
  }
  if (hf == NULL) {
    ko=MSRWR6;
    mistake(ko,m16);
    return ko;
  }
  if (hf->cpol > 0) {
    ko=MSPDF3;
    mistake(ko,m75);
    return ko;
  }
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;

  ind = FindInCat(cat,lcatt,namerecp,T_RECNAME,0,hf->ver2);
  //  printf("sioriwr insert %s %d\n", namerecp, ind);
  if (ind < -1) { ko = ind; return ko; }
  if (ind<0) {    /* новая зaпиcь */
    lenb = (size_t)len * LENFORMT(form);
    //    printf("sioriwr %s len=%d f=%d lenb=%ld\n", namerecp, len, form, lenb);
    ind = InsertInCat(&hf,namerecp,T_RECNAME,lenb,form);
    cat = hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */
    if (ind < 0) { ko = ind; return ko; }
    addr=(*cat)[ind].lctaddr;
/*     hf->faddr += lenb; */
    hf->modpr =1;
  }
  else {          /* cтapaя зaпиcь */
    lenb = (size_t)len * LENFORMT((*cat)[ind].lctform);
    addr = (*cat)[ind].lctaddr;
    if (index < 0) {		/* расширение последней записи */
      /* printf(">>>>\n"); */
      /* printf("sioriwr index=%d arrd=%ld len=%ld += %ld faddr=%ld\n",  */
      /* 	     index, addr, (*cat)[ind].lctlen,  */
      /* 	     addr + (*cat)[ind].lctlen,  */
      /* 	     hf->faddr); */
      if (addr + (*cat)[ind].lctlen != hf->faddr) {
	ko=MSRWR7;
	mistake(ko,m80);
	return ko;
      } else {
	index = (*cat)[ind].lctlen /LENFORMT(form);
	(*cat)[ind].lctlen += lenb;
	hf->faddr += lenb;
	//printf("#1 faddr = %zd %zd\n", hf->faddr, lenb);
      }
    } else {
      bindex = (size_t)index * LENFORMT(form);
      if ((*cat)[ind].lctlen < lenb + bindex) {
	mistake((int)(*cat)[ind].lctlen,m19);
	ko=MSRWR2; return ko;
      }
      else if ((*cat)[ind].lctform > form) {
	mistake((*cat)[ind].lctform,m20);
	ko=MSRWR2; return ko;
      }
    }
  }
  if (fseek(hf->filptr, addr+index*LENFORMT(form), SEEK_SET) != 0 ) {
    mistake((int)addr,m21);
    ko=MSRWR3; return ko;
  }
  /* printf("sioriwr offset=%ld lenb=%ld\n", addr+index*LENFORMT(form), lenb); */
  if ((l = fwrite(array,1,lenb,hf->filptr)) != lenb) {
    /* printf("wr=%d lenb=%d addr=%d\n",l,lenb,addr);  */
    ko=MSRWR4;
    mistake(ko,m22);
    return ko;
  }
  return 0;
} /* sioriwr */



int siorwr (HF*  hf       /* дecкpиптop фaйлa     */
           ,const char* namerecp /* имя зaпиcи           */
           ,void* array    /* мaccив oбмeнa        */
           ,int   len      /* eгo длинa            */
           ,int   form     /* фopmaт eгo элemeнтoв */
           )
{
  int ind = 0, ko;
  hf->trunc = 1;
  ko = sioriwr(hf, namerecp, array, ind, len, form);
  //trunc = 0;
  return ko;
} /* siorwr */


/* ============================================================== SIOGWR = */

int siogwr (HF*  hf       /* дecкpиптop фaйлa     */
           ,const char* namegrp  /* имя группы           */
           ,int   number   /* номер экземпляра     */
           ,const char* namepolp /* имя поля             */
           ,void* array    /* мaccив oбмeнa        */
           ,int   len      /* eгo длинa            */
           ,int   form     /* фopmaт eгo элemeнтoв */
           )
{
  int lcatt,
    ind, indp, indp_, indg,
    l, i, i_;
  size_t addr, lenb, lenp, lenr, lenw;
  MCAT* cat;
  HCAT* hcat;
  char namepol [24], /* бeз xвocтoвыx пpoбeлoв */
       namerecc[24], /* бeз xвocтoвыx пpoбeлoв */
       namegr  [24]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko, find = 0;
  int lenname = (hf->ver2 ? 23 : 13);

  sprintf(msgext,"%.13s.%.13s#%d",namegrp,namepolp,number);
  if (hf == NULL) {
    ko=MSGWR1;
    mistake(ko,m23);
    return ko;
  }
  if (hf->cpol > 0) {
    ko=MSPDF3;
    mistake(ko,m75);
    return ko;
  }
  cat  = hf->catptr;
  hcat = hf->hcatptr;
  lcatt=hf->lencat;
  indg = FindInCat(cat,lcatt,namegrp,T_GRPNAME,0,hf->ver2);
  if (indg < -1) { ko = indg; return ko; }
  if (indg<0) {    /* новая зaпиcь */
    ko=MSGWR3; mistake(ko,m25); return ko;
  }
  l=strlen(namepolp); if (l>lenname) l=lenname;
  strcpy (namepol,empty_name); strncpy(namepol,namepolp,l);
  for (indp_=indp=indg+1; indp_ <= indg+ (int) (*cat)[indg].lctaddr; indp_++) {
    if ((*cat)[indp].lcttype == T_CATEXT) indp++;
    b=(*cat)[indp].lctname;
    l=strlen(b); if (l>lenname) l=lenname;
    strcpy (namerecc,empty_name); strncpy(namerecc,b,l);
    if (strcmp(namepol,namerecc) == 0 && (*cat)[indp].lcttype == T_POLNAME) {
      if ((*cat)[indp].lcttype == T_POLNAME ) {find = 1; break;}
    }
    indp++;
  }
  if (!find) { ko=MSGWR4; mistake(ko,m26); return ko; }
  form = (*cat)[indp].lctform;
  lenp = (*cat)[indp].lctlen / LENFORMT(form);
  if (len > lenp) { ko=MSGRD5; mistake(ko,m27); return ko; }
  if (number <= 0) { ko=MSGRD0; mistake(ko,m74); return ko; }
  ind = FindInCat(cat,lcatt,namegrp,T_RECNAME,number,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind<0) {    /* новый экземпляр */
    lenr = (*cat)[indg].lctlen;
/*     form = (*cat)[indg].lctform; */
    ind = InsertInCat(&hf,namegrp,T_RECNAME,lenr,0);
    cat=  hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */
    if (ind < 0) { ko = ind; return ko; }
    (*cat)[ind].lctnom =number;	/* иначе не было предусмотрено */
    lenb = (*cat)[indp].lctlen;
    if (lenb < len * LENFORMT((*cat)[indp].lctform)) {
      mistake((int)(*cat)[indp].lctlen,m29); ko=MSGWR6; return ko;
    }
    else if ((*cat)[indp].lctform != form) {
      mistake((*cat)[indp].lctform,m30); ko=MSGWR6; return ko;
    }
    addr=(*cat)[ind].lctaddr;
    //    printf("siogwr ind=%d seek addr0n=%ld\n", ind, addr);
/*     hf->faddr += lenr; */
    hf->modpr =1;
  }
  else         {    /* старая запись */
    lenb = (*cat)[indp].lctlen;
    addr = (*cat)[ind].lctaddr;
    //    printf("siogwr seek addr0s=%ld\n", addr);
    if (lenb < len * LENFORMT((*cat)[indp].lctform)) {
      mistake((int)(*cat)[indp].lctlen,m31); ko=MSGWR6; return ko;
    }
    else if ((*cat)[indp].lctform != form) {
      mistake((*cat)[indp].lctform,m32); ko=MSGWR6; return ko;
    }
  }

/*   for (i = indg+1; i < indp; i++) addr += (size_t) (*cat)[i].lctlen; */
  for (i_=i=indg+1; i_ < indp_; i_++) {
    if ((*cat)[i].lcttype == T_CATEXT) i++;
    addr += (size_t) (*cat)[i].lctlen;
    i++;
  }

  //  printf("siogwr seek %ld\n", addr);
  if (fseek(hf->filptr,addr,SEEK_SET) != 0 ) {
    mistake((int)addr,m33);
    ko=MSGWR7; return ko;
  }
  if ((lenw=fwrite(array,1,lenb,hf->filptr)) != lenb) {
    ko=MSGWR9;
    mistake(ko,m34);
    return ko;
  }
  return 0;
} /* siogwr */



/* ============================================================= SIOGDEF = */
int siogdef (HF*  hf       /* дecкpиптop фaйлa     */
            ,const char* namegrp  /* имя группы           */
            ,int   numpol   /* число полей          */
            )
{
  int lcatt, ind, l;
  MCAT* cat;
  HCAT* hcat;
  char namegr  [24], /* бeз xвocтoвыx пpoбeлoв */
       namerecc[24]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  sprintf(msgext,"%.13s",namegrp);
  if (hf == NULL) {
    ko=MSGDF3;
    mistake(ko,m35);
    return ko;
  }
  cat  = hf->catptr;
  hcat = hf->hcatptr;
  lcatt=hf->lencat;

  ind = FindInCat(cat,lcatt,namegrp,T_GRPNAME,0,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0) { /* новая запись */
    ind = InsertInCat(&hf,namegrp,T_GRPNAME,0,0);
    cat=  hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */
    (*cat)[ind].lctaddr=(size_t) numpol; /* особенность группы */
    hf->modpr =1;
  }
  else {         /* старая запись */
    mistake((*cat)[ind].lcttype,m38);
    ko=MSGDF2; return ko;
  }
  hf->cpol = numpol;
  hf->indgr= ind;
  return 0;
} /* siogdef */



/* ============================================================ SIOGDEFP = */
int siogdefp (HF*  hf       /* дecкpиптop фaйлa     */
             ,const char* namepolp /* имя группы           */
             ,int   len      /* eгo длинa            */
             ,int   form     /* фopmaт eгo элemeнтoв */
             )
{
  int ind, l;
  MCAT* cat;
  HCAT* hcat;
  char namepol [24], /* бeз xвocтoвыx пpoбeлoв */
       namerecc[24]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  sprintf(msgext,"%.13s",namepolp);
  if (hf == NULL) {
    ko=MSPDF2;
    mistake(ko,m39);
    return ko;
  }
  if (hf->cpol <= 0) {
    ko=MSPDF1;
    mistake(ko,m40);
    return ko;
  }
  cat  = hf->catptr;
  hcat = hf->hcatptr;
/*   l=strlen(namepolp); if (l>13) l=13; */
/*   strcpy (namepol,"             "); strncpy(namepol,namepolp,l); */
/*   if (hf->lencat >= hcat->catmlen) { */
/*     ko = MSCAT; mistake(hf->lencat,m41); return ko; */
/*   } */

  ind = InsertInCat(&hf,namepolp,T_POLNAME,len * LENFORMT(form),form);
  cat=  hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */

/*   ind = hf->lencat; hf->lencat++; */
/*   (*cat)[ind].lcttype=T_POLNAME; */
/*   strcpy((*cat)[ind].lctname,namepol); */
/*   (*cat)[ind].lctlen =len * LENFORMT(form); */
/*   (*cat)[ind].lctform=form; */
/*   (*cat)[ind].lctaddr=0; */
  (*cat)[hf->indgr].lctlen += len * LENFORMT(form);
  hf->cpol --;
  return 0;
} /* siogdefp */



/* ============================================================== SIORRD = */
int siorrd (HF*  hf       /* дecкpиптop фaйлa     */
           ,const char* namerecp /* имя зaпиcи           */
           ,void* array    /* мaccив oбмeнa        */
           ,int   len      /* eгo длинa            */
           ,int   form     /* фopmaт eгo элemeнтoв */
           )
{
  int ind = 0, rlen;
  hf->trunc = 1;
  rlen = siorird(hf, namerecp, array, ind, len, form);
  hf->trunc = 0;
  return rlen;
} /* siorrd */

/* ============================================================== SIOGETLEN = */
int siorgetlen (HF*  hf       /* дecкpиптop фaйлa     */
	       ,const char* namerecp /* имя зaпиcи           */
	       )
{
  int ind = 0, rlen, ko;
  int lcatt, l;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,namerecp,T_RECNAME,0,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  rlen = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform);
  return rlen;
} /* siorgetlen */




/* ============================================================== SIORIRD = */
int siorird (HF*  hf       /* дecкpиптop фaйлa     */
            ,const char* namerecp /* имя зaпиcи           */
            ,void* array    /* мaccив oбмeнa        */
            ,int   index    /* индекс в массиве     */
            ,int   len      /* eгo длинa            */
            ,int   form     /* фopmaт eгo элemeнтoв */
            )
{
  int lcatt, ind, l;
  size_t bindex;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  //  char namerec[14],  /* бeз xвocтoвыx пpoбeлoв */
  //       namerecc[14]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  if (hf == NULL) {
    ko=MSRRD6;
    mistake(ko,m42);
    return ko;
  }
  //printf("siorrd: name=%s buff=%p\n", namerecp, array);
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,namerecp,T_RECNAME,0,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  if (len == 0) {		/* запрошена вся запись */
    len = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform);
    //    printf("siorrd %s len=%d %d\n", namerecp, len, (*cat)[ind].lctlen);
  }
  lenb = (size_t)len * LENFORMT((*cat)[ind].lctform);
  bindex = (size_t)index * LENFORMT((*cat)[ind].lctform);
  addr=(*cat)[ind].lctaddr;
  if ((*cat)[ind].lctlen > lenb + bindex) {
    /* запрошена не вся запись */
    //    printf("siorird bufsize %d %d %d %d %d\n", (*cat)[ind].lctlen, lenb + bindex, len, lenb, bindex);
    if (hf->trunc) { mistake((int)(*cat)[ind].lctlen,m76); ko=MSRRD3; return ko; }
  }
  else if ((*cat)[ind].lctlen < lenb + bindex) {
    /* запрошено больше записи */
    if (hf->trunc) lenb = (*cat)[ind].lctlen - bindex;
    else { mistake((int)(*cat)[ind].lctlen,m45); ko=MSRRD3; return ko; }
  }
  if ((*cat)[ind].lctform > form) {
    mistake((*cat)[ind].lctform,m46); ko=MSRRD3; return ko;
  }
  if (fseek(hf->filptr,addr+bindex,SEEK_SET) != 0 ) {
    mistake((int)addr,m47); ko=MSRRD4; return ko;
  }
  if ((lenr=Fread(array,1,lenb,hf->filptr)) != lenb) {
    ko=MSRRD5; mistake(ko,m48); return ko;
  }
  hf->trunc = 0;
  return lenb / LENFORMT((*cat)[ind].lctform);
} /* siorird */



/* ============================================================== SIOARRDEF = */
int sioadef(HF* hf, const char*name, int ndims, int*dims, int fmt)
{
  //printf("sioadef %s, ndims=%d, fmt=%d\n", name, ndims, fmt);
  //#define T_ARRDEF        5
  int lcatt, ind, indd, i;
  MCAT* cat;
  HCAT* hcat;
  char namearr  [24]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko = 0;
  size_t larray = 1;

  sprintf(msgext,"%.13s",name);
  if (hf == NULL) {
    ko=MSGDF3;
    mistake(ko,m35);
    return ko;
  }
  cat  = hf->catptr;
  hcat = hf->hcatptr;
  lcatt=hf->lencat;

  ind = FindInCat(cat,lcatt,name,T_ARRDEF,0,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0) { /* новая запись */
    for (i = 0; i < ndims; i++) {
      larray *= dims[i];
      //printf("larray %d %d %d\n", i, dims[i], larray);
    }
    larray *= LENFORMT(fmt); /* вычисляем длину массива */
    //printf("sioadef len=%d\n", larray);
    ind = InsertInCat(&hf,name,T_ARRDEF,larray,fmt);
    cat=  hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */
    (*cat)[ind].lctnom = ndims;   /* размерность массива */
    (*cat)[ind].lctlen = larray;       /* длина массива */
    //    (*cat)[ind].lctaddr= (size_t)0; /* адрес в памяти */
    hf->modpr =1;
  } else {         /* старая запись */
    mistake((*cat)[ind].lcttype,m38);
    ko=MSGDF2; return ko;
  }
    //(*cat)[ind].lctlen = larray; 
  
  //hf->faddr += (*cat)[ind].lctlen;
  //printf("#2 faddr = %ld %ld\n", hf->faddr, (*cat)[ind].lctlen);

  for (i = 0; i < ndims; i++) {
    //printf("sioadef, i=%d of %d\n", i, ndims);
    indd = FindInCat(cat,lcatt,name,T_ARRDIM,i,hf->ver2);
    //printf("sioadef, indd-=%d\n", indd);
    if (indd < -1) { ko = ind; return ko; }
    if (indd < 0) { /* новая запись */
      //printf("sioadef, insert %s %d %d %d\n", name, T_ARRDIM, i, fmt);
      indd = InsertInCat(&hf,name,T_ARRDIM,i,fmt);
      //printf("sioadef, indd+=%d\n", indd);
       cat=  hf->catptr; /* это необходимо, т.к. каталог может быть перевыделен */
      (*cat)[indd].lctnom = i; /* размерность массива */
      (*cat)[indd].lctlen=(size_t)dims[i] * LENFORMT((*cat)[i].lctform); /* длина измерения */
      (*cat)[indd].lctform = (*cat)[ind].lctform; /* формат */
      //printf("i=%d len=%d size=%d\n", i, (*cat)[ind].lctlen, dims[i] * LENFORMT((*cat)[i].lctform));
    }
  }
  return ko;
} /* sioadef */


/* ============================================================== SIOARRWR = */
int sioawr (HF* hf, const char* name, void* array, int len, int fmt)
{
  //printf("## sioawr %s, %p len=%d fmt=%d\n", name, array, len, fmt);
  //#define T_ARRBASE       7
  int lcatt, ind;
  size_t addr, lenb, l, bindex, lenfromcat;
  MCAT* cat;
  HCAT* hcat;
  //  char namerec[14],  /* бeз xвocтoвыx пpoбeлoв */
  //       namerecc[14]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  sprintf(msgext,"%.13s",name);
  if (!hf->ver2) {
    ko=MSNWR;
    mistake(ko,m79);
    return ko;
  }
  if (hf == NULL) {
    ko=MSRWR6;
    mistake(ko,m16);
    return ko;
  }
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;

  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2);
  //printf("sioawr insert %s %d\n", name, ind);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0) { ko = ko=MSRRD2; mistake(ko, m90); return ko; }
  lenfromcat = (*cat)[ind].lctlen;
  lenb = (size_t)len * LENFORMT((*cat)[ind].lctform);
  if (lenb == 0) {
    //printf("sioawr - empty array %s, not writed\n", name); /* TODO */
    return 0;;
  }
  if (lenfromcat != (size_t)len * LENFORMT((*cat)[ind].lctform)) {
    printf("sioawr - bad lenght of array %s cat %zd != param %d\n", /* TODO */
	   name, lenfromcat, len); 
    return -1;
  }
  lenb = (size_t)len * LENFORMT((*cat)[ind].lctform);
  addr = (*cat)[ind].lctaddr;
  if (fseek(hf->filptr, addr, SEEK_SET) != 0 ) {
    mistake((int)addr,m21);
    ko=MSRWR3; return ko;
  }
  //printf("@@ sioawr offset=%zd lenb=%zd\n", addr, lenb);
  if ((l = fwrite(array,1,lenb,hf->filptr)) != lenb) {
    /* printf("wr=%d lenb=%d addr=%d\n",l,lenb,addr);  */
    ko=MSRWR4;
    mistake(ko,m22);
    return ko;
  }
  if (0) { // тестовая печать
    if (fmt == 28) { 
      int ll = len, ii; 
      if (ll > 10) ll = 10; 
      printf("lb: "); 
      for (ii = 0; ii < ll; ii++) printf(" %zd ", ((size_t*)array)[ii]); 
      printf("\n"); 
    } else if (fmt == 18) { 
      int ll = len, ii; 
      if (ll > 10) ll = 10; 
      printf("db: "); 
      for (ii = 0; ii < ll; ii++) printf(" %f ", ((double*)array)[ii]); 
      printf("\n"); 
    }
  }
  return 0;
} /* sioawr */


/* ============================================================== SIOARD = */
int  sioard (HF* hf, const char* name, void* array, int len, int form)
{
  int lcatt, ind, l, lenp;
  size_t bindex, faddr;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  //  char namerec[14],  /* бeз xвocтoвыx пpoбeлoв */
  //       namerecc[14]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko;

  if (hf == NULL) {
    ko=MSRRD6;
    mistake(ko,m42);
    return ko;
  }
  //printf("sioard: name=%s buff=%p len=%d form=%d\n", name, array, len, form);
  lenp = len;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  if (len == 0) {		/* запрошена вся запись */
    len = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform);
    //    printf("sioard %s len=%d %d\n", namerecp, len, (*cat)[ind].lctlen);
  }
  //printf("sioard: name=%s buff=%p len=%d %d form=%d\n", name, array, len, lenp, form);
  if (len > 0) {
    lenb = (size_t)len * LENFORMT((*cat)[ind].lctform);
    bindex = 0; /* (size_t)index * LENFORMT((*cat)[ind].lctform); */
    addr=(*cat)[ind].lctaddr;
    if ((*cat)[ind].lctlen > lenb + bindex) {
      /* запрошена не вся запись */
      //    printf("sioard bufsize %d %d %d %d %d\n", (*cat)[ind].lctlen, lenb + bindex, len, lenb, bindex);
      if (hf->trunc) { mistake((int)(*cat)[ind].lctlen,m76); ko=MSRRD3; return ko; }
    }
    else if ((*cat)[ind].lctlen < lenb + bindex) {
      /* запрошено больше записи */
      if (hf->trunc) lenb = (*cat)[ind].lctlen - bindex;
      else { mistake((int)(*cat)[ind].lctlen,m45); ko=MSRRD3; return ko; }
    }
    if ((*cat)[ind].lctform > form) {
      mistake((*cat)[ind].lctform,m46); ko=MSRRD3; return ko;
    }
    faddr = addr+bindex;
    if (fseek(hf->filptr,faddr,SEEK_SET) != 0 ) {
      mistake((int)addr,m47); ko=MSRRD4; return ko;
    }
    lenr = Fread(array,1,lenb,hf->filptr);
    //printf("@@ sioard read=%zd from %zd seek=%zd\n", lenr, lenb, faddr);
    if (lenr != lenb) {
      ko=MSARD5; mistake(ko,m88); return ko;
    }
    if (0) { // тестовая печать
      if (form == 28) { 
	int ll = len, ii; 
	if (ll > 10) ll = 10; 
	printf("lb: "); 
	for (ii = 0; ii < ll; ii++) printf(" %zd ", ((size_t*)array)[ii]); 
	printf("\n"); 
      } else if (form == 18) { 
	int ll = len, ii; 
	if (ll > 10) ll = 10; 
	printf("db: "); 
	for (ii = 0; ii < ll; ii++) printf(" %f ", ((double*)array)[ii]); 
	printf("\n"); 
      }
    }
  } else { 
    //printf("sioard - len of array = 0; not read\n"); /* TODO */
    lenr = 0; 
  } 
  //printf("sioard ret=%d\n", lenr / LENFORMT((*cat)[ind].lctform)); 
  hf->trunc = 0;
  return lenr / LENFORMT((*cat)[ind].lctform);
} /* sioard */


/* ============================================================== SIOAGETLEN = */
int  sioagetlen (HF* hf, const char* name)
// выдача длины вектора массма в элемента
{
  int ind = 0, rlen=-1, ko;
  int lcatt, l;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2);
  //printf("sioagetlen %s ind=%d\n", name, ind);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  rlen = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform);
  //printf("!! sioagetlen name=%s ind=%d len=%d\n", name, ind, rlen);
  return rlen;
} /* sioagetlen */

int  sioagetlenb (HF* hf, const char* name)
// то же самое, в байтах
{
  int ind = 0, rlen=-1, ko;
  int lcatt, l;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2);
  //printf("sioagetlen %s ind=%d\n", name, ind);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  rlen = (*cat)[ind].lctlen;
  //printf("!! sioagetlen name=%s ind=%d len=%d\n", name, ind, rlen);
  return rlen;
} /* sioagetlenb */


/* ============================================================== SIOAGETDIMS = */
int  sioagetdims (HF* hf, const char* name)
{
  int ind = 0, res =-1, ko;
  int lcatt, l;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  //printf("@@ sioagetdims FindInCat name=%s t=%d nom=%d\n", name, T_ARRDEF, -1);
  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  //printf("@@ sioagetdims FindInCat ind=%d cat=%p\n", ind, cat);
  res = (*cat)[ind].lctnom;
  return res;
} /* sioagetdims */


/* ============================================================== SIOAGETDIM = */
int  sioagetdim (HF* hf, const char* name, int dim)
{
  int ind = 0, res = -1, ko;
  int lcatt, i, ndims;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  //printf("@@ sioagetdim name=%s dim=%d\n", name, dim);
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  /* indd = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2); */
  /* if (indd < -1) { ko = ind; return ko; } */
  /* if (indd < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; } */
  /* ndims = (*cat)[ind].lctnom; */
  /* for (i = 0; i < ndims; i++) { */
  /*   res = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform); */
  /* } */
  //printf("@@ sioagetdim FindInCat name=%s t=%d nom=%d\n", name, T_ARRDIM, dim);
  ind = FindInCat(cat,lcatt,name,T_ARRDIM,dim,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; }
  //printf("@@ sioagetdim FindInCat ind=%d cat=%p\n", ind, cat);
  res = (*cat)[ind].lctlen / LENFORMT((*cat)[ind].lctform);
  //printf("@@ sioagetdim res = %d\n", res);
  return res;
} /* sioagetdim */



/* ============================================================== SIOAGETFMT = */
int  sioagetfmt (HF* hf, const char* name)
{
  int ind = 0, res = -1, ko;
  int lcatt, i;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  //printf("@@ sioagetdim name=%s dim=%d\n", name, dim);
  hf->trunc = 1;
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  ind = FindInCat(cat,lcatt,name,T_ARRDEF,-1,hf->ver2); 
  if (ind < -1) { ko = ind; return ko; } 
  if (ind < 0)  { ko=MSRRD2; mistake(ko,m44); return ko; } 
  res = (*cat)[ind].lctform; 
  //printf("@@ sioagetdim res = %d\n", res);
  return res;
} /* sioagetfmt */



/* ============================================================== SIOGRD = */
int siogrd (HF*  hf       /* дecкpиптop фaйлa     */
           ,const char* namegrp  /* имя группы           */
           ,int   number   /* номер экземпляра     */
           ,const char* namepolp /* имя поля             */
           ,void* array    /* мaccив oбмeнa        */
           ,int   len      /* eгo длинa            */
           ,int   form     /* фopmaт eгo элemeнтoв */
           )
{
  int ind = 0, rlen;
  hf->trunc = 1;
  rlen = siogird(hf, namegrp, number, namepolp, array, ind, len, form);
  hf->trunc = 0;
  return rlen;
} /* siogrd */



int siogird (HF*  hf       /* дecкpиптop фaйлa     */
            ,const char* namegrp  /* имя группы           */
            ,int   number   /* номер экземпляра     */
            ,const char* namepolp /* имя поля             */
            ,void* array    /* мaccив oбмeнa        */
            ,int   index    /* индекс в массиве     */
            ,int   len      /* eгo длинa            */
            ,int   form     /* фopmaт eгo элemeнтoв */
            )
{
  int lcatt, ind, indp, indp_, indg, l, i, i_;
  size_t bindex;
  size_t addr, lenb, lenr;
  MCAT* cat;
  HCAT* hcat;
  char namepol [24], /* бeз xвocтoвыx пpoбeлoв */
       namerecc[24], /* бeз xвocтoвыx пpoбeлoв */
       namegr  [24]; /* бeз xвocтoвыx пpoбeлoв */
  char *b;
  int ko, find = 0;
  int lenname = (hf->ver2 ? 23 : 13);

  sprintf(msgext,"%.13s.%.13s#%d",namegrp,namepolp,number);
  if (hf == NULL) {
    ko=MSGRD1;
    mistake(ko,m49);
    return ko;
  }
  cat=  hf->catptr;
  hcat= hf->hcatptr;
  lcatt=hf->lencat;
  indg = FindInCat(cat,lcatt,namegrp,T_GRPNAME,0,hf->ver2);
  if (indg < -1) { ko = indg; return ko; }
  if (indg == -1) { ko=MSGRD3; mistake(ko,m51); return ko; }
  l=strlen(namepolp); if (l>lenname) l=lenname;
  strcpy (namepol,empty_name); strncpy(namepol,namepolp,l);
  for (indp_=indp=indg+1; indp_ <= indg+ (int) (*cat)[indg].lctaddr; indp_++) {
    if ((*cat)[indp].lcttype == T_CATEXT) indp++;
    b=(*cat)[indp].lctname;
    l=strlen(b); if (l>lenname) l=lenname;
    strcpy (namerecc,empty_name); strncpy(namerecc,b,l);
    //    printf("siogird find '%s' '%s' %d\n", namepol, namerecc, (*cat)[indp].lcttype);
    if (strcmp(namepol,namerecc) == 0 && (*cat)[indp].lcttype == T_POLNAME) {
      if ((*cat)[indp].lcttype == T_POLNAME ) {find = 1; break;}
    }
    indp++;
  }
  if (!find) { ko=MSGRD4; mistake(ko,m52); return ko; }
  form = (*cat)[indp].lctform;
  bindex = (size_t)index * LENFORMT(form);
  if (number <= 0) { ko=MSGWR0; mistake(ko,m74); return ko; }
  ind = FindInCat(cat,lcatt,namegrp,T_RECNAME,number,hf->ver2);
  if (ind < -1) { ko = ind; return ko; }
  if (ind < 0) {    /* новый экземпляр */
    ko=MSGRD0; mistake(ko,m54); return ko;
  }
  else         {    /* старая запись */
    lenb = (*cat)[indp].lctlen - bindex;
    addr = (*cat)[ind].lctaddr + bindex;
    if (lenb < len * LENFORMT((*cat)[indp].lctform)) {
      /* запрошено больше записи */
      if (hf->trunc) ;
      else { mistake((int)(*cat)[ind].lctlen,m55); ko=MSGRD6; return ko; }
    }
    else if (lenb > len * LENFORMT((*cat)[indp].lctform)) {
      /* запрошена не вся запись */
      if (hf->trunc) { mistake((int)(*cat)[ind].lctlen,m77); ko=MSGRD6; return ko;}
      else lenb = (size_t)len * LENFORMT((*cat)[indp].lctform);
    }
    if ((*cat)[indp].lctform != form) {
      mistake((*cat)[indp].lctform,m56); ko=MSGRD6; return ko;
    }
  }

/*   for (i = indg+1; i < indp; i++) addr += (size_t) (*cat)[i].lctlen; */
  for (i_=i=indg+1; i_ < indp_; i_++) {
    if ((*cat)[i].lcttype == T_CATEXT) i++;
    addr += (size_t) (*cat)[i].lctlen;
    i++;
/*     printf("grd: i_=%d i=%d a=%d\n",i_,i,addr); */
  }

  if (fseek(hf->filptr,addr,SEEK_SET) != 0 ) {
    mistake((int)addr,m57); ko=MSGRD7; return ko;
  }
  if ((lenr=Fread(array,1,lenb,hf->filptr)) != lenb) {
    ko=MSGRD9; mistake(ko,m58); return ko;
  }
  hf->trunc = 0;
  return lenb / LENFORMT((*cat)[indp].lctform);
} /* siogird */



/* =========================================================== SIOLENCAT */
int siolencat(HF* hf)
{
/*   return hf->hcatptr->catrlen; */
  return hf->lencat;
} /* siolencat */


/* =========================================================== SIOGETCAT */
int siogetcat(HF* hf,
	      int nl,
	      char** name,
	      int* num,
	      int* type,
	      int* len,
	      int* fmt,
	      size_t* adr)
{
  MCAT* cat = hf->catptr;
/*   int lencat = hf->hcatptr->catrlen; */
  int lencat = hf->lencat;
  int ind;
  static char nm[24];
  int lenname = (hf->ver2 ? 23 : 13);
  if (nl >= lencat) return -1;
/*   printf("siogetcat, nl=%d\n", nl); */
  strncpy(nm,(*cat)[nl].lctname,lenname); nm[lenname]=0x00;
  *name = nm;
  *num = (*cat)[nl].lctnom;
  *type = (*cat)[nl].lcttype;
  *fmt  = (*cat)[nl].lctform;
  if (((*cat)[nl].lcttype == T_RECNAME && (*cat)[nl].lctnom == 0)
       || (*cat)[nl].lcttype == T_POLNAME)
      *len =  (*cat)[nl].lctlen / LENFORMT((*cat)[nl].lctform);
  else
      *len =  (*cat)[nl].lctlen;
  *adr =  (*cat)[nl].lctaddr;
/*   printf("siogetcat, name=%s num=%d type=%d len=%d fmt=%d adr=%ld\n", */
/* 	 *name, *num, *type, *len, *fmt, *adr); */
  return 0;
} /* siogetcat */


/* =========================================================== SIOGETITEMTYPE */
int  siogetitemtype(HF* hf, int nl)
{
  MCAT* cat = hf->catptr;
/*   int lencat = hf->hcatptr->catrlen; */
  int lencat = hf->lencat;
  int ind;
  int type, num, fmt;
  int lenname = (hf->ver2 ? 23 : 13);
  if (nl >= lencat) return -1;
/*   printf("siogetcat, nl=%d\n", nl); */
  num = (*cat)[nl].lctnom;
  type = (*cat)[nl].lcttype;
  fmt  = (*cat)[nl].lctform;
  return type;
}


/* =========================================================== SIOGETITEMFMT */
int  siogetitemfmt(HF* hf, int nl)
{
  MCAT* cat = hf->catptr;
/*   int lencat = hf->hcatptr->catrlen; */
  int lencat = hf->lencat;
  int ind;
  int type, num, fmt;
  int lenname = (hf->ver2 ? 23 : 13);
  if (nl >= lencat) return -1;
/*   printf("siogetcat, nl=%d\n", nl); */
  num = (*cat)[nl].lctnom;
  type = (*cat)[nl].lcttype;
  fmt  = (*cat)[nl].lctform;
  return fmt;
}


/* =========================================================== SIOGETITEMNAME */
int  siogetitemname(HF* hf, int nl, char* nm)
{
  MCAT* cat = hf->catptr;
/*   int lencat = hf->hcatptr->catrlen; */
  int lencat = hf->lencat;
  int ind;
  int type, num, fmt;
  int lenname = (hf->ver2 ? 23 : 13);
  if (nl >= lencat) return -1;
/*   printf("siogetcat, nl=%d\n", nl); */
  strncpy(nm,(*cat)[nl].lctname,lenname); nm[lenname]=0x00;
  num = (*cat)[nl].lctnom;
  type = (*cat)[nl].lcttype;
  fmt  = (*cat)[nl].lctform;
  return strlen(nm);
}


/* ============================================================== GETMSG = */
void siogetmsg (char *p)
{
  strncpy(p,msg,80);
} /* siogetmsg */



void mistake (int ko
             ,char* text
             )
{
  sprintf(msg,"%s %d:%.39s\n",text,ko,msgext);
} /* mistake */



/* =========================================================== чтение HCAT */
int read_hcat(HCAT* hcat, HF* hf)
{
  char *buf;
  int i, ko, catfaddr;
  buf = (char*)malloc(16);

  if ((i = Fread(buf,1,16,hf->filptr)) != 16) {
    ko = MSFOP3; mistake(ko,m7); return ko;
  }
  //for (i=0; i<16; i++) printf("%02x ", buf[i]);
  //printf("Fread\n");

  /* fseek(hf->filptr,0,SEEK_SET); */
  /* if ((i = fread(buf,1,16,hf->filptr)) != 16) { */
  /*   ko = MSFOP3; mistake(ko,m7); return ko; */
  /* } */
  /* for (i=0; i<16; i++) printf("%02x ", buf[i]); */
  /* printf("fread\n"); */
  /* exit(-1); */

  memcpy(&hcat->catver2,  &buf[0] ,1);
  memcpy(&hcat->catmlen,  &buf[1] ,2);
  memcpy(&hcat->catrlen,  &buf[3] ,2);
  memcpy(&hcat->catdelkey_,&buf[5] ,2);
  memcpy(&catfaddr,       &buf[7] ,4);
  hcat->catfaddr = catfaddr;
  memcpy(&hcat->nexts    ,&buf[11],2);
  hcat->date_y = buf[13];
  hcat->date_m = buf[14];
  hcat->date_d = buf[15];
  free(buf);
  /* printf("### cat: catver2 = %02x\n", hcat->catver2); */
  /* printf("### cat: catmlen = %d\n", hcat->catmlen); */
  /* printf("### cat: catrlen = %d\n", hcat->catrlen); */
  /* printf("### cat: delkey_ = %d\n", hcat->catdelkey_); */
  /* printf("### cat: catfaddr= %zd\n", hcat->catfaddr); */
  /* printf("### cat: nexts   = %d\n",  hcat->nexts); */
  return 0;
} /* read_hcat */



/* =========================================================== чтение MCAT */
int read_mcat(MCAT* cat, HF* hf)
{
  char *buf, *b;
  HCAT *hcat;
  int i, n, ko, ib, ie, lwr, lencat;
  int lcatt, ind;
  size_t faddr;
  hcat=hf->hcatptr;
  lencat = hcat->catmlen*(hcat->nexts+1);
  printf("read_mcat not emplemented\n");
  exit(-1);
  //printf("rlen %d mlen %d nexts %d\n",hcat->catrlen,hcat->catmlen,hcat->nexts); 
  /* lcatt = hcat->catmlen*24*(hcat->nexts+1); */
  /* buf = b = (char*)malloc(lcatt); */
  /* hcat->catfaddr = 16; */
  /* //printf("read_mcat len buf=%d ext=%d\n",lcatt,hcat->nexts);  */
  /* ib = 0; */
  /* for (n = 0; n <= hcat->nexts; n++) { */
  /*   //printf("### n=%d ind=%d nexts=%d\n", n, ind, hcat->nexts); */
  /*   if (n > 0) { */
  /*     ind = FindInCat(cat,(hcat->catrlen),"## Extent ## ",T_CATEXT,n,hf->ver2); */
  /*     if (ind < 0) {  */
  /* 	printf("read_mcat ext=%d\n",n);  */
  /*       printf("#### Errot in mcat,  %d items\n", n); */
  /*       hf->lencat = hcat->catrlen = n; */
  /* 	ko=MSFOP5; mistake(ko,m9); return ko; */
  /*     } */
  /*     faddr = (*cat)[ind].lctaddr; */
  /*     //printf("read_mcat ext=%d seek %d %d\n",n,ind,faddr);   */
  /*     fseek(hf->filptr,faddr,SEEK_SET); */
  /*   } */
  /*   //printf("### n=%d ind=%d\n", n, ind); */
  /*   //printf("read_mcat buf=%04x\n",buf);  */
  /*   lwr = min(hcat->catmlen,lencat)*24; */
  /*   if ((i=Fread(b,1,lwr,hf->filptr)) != lwr) { */
  /*     printf("read_mcat: n %d read %d wonted %d lencat=%d\n",n, i,lwr,lencat);  */
  /*     ko = MSFOP3; mistake(ko,m7); return ko; */
  /*   } */
  /*   ie = ib + hcat->catmlen; */
  /*   lencat -= hcat->catmlen; */
  /*   //printf("read_mcat i=%d %d\n",ib,ie);  */
  /*   if (ie > hcat->catrlen) ie = hcat->catrlen; */
  /*   for (i = ib; i < ie; i++) { */
  /*     //printf("### ind=%d %d %d of %d\n", ind, i, ib, ie); */
  /*     (*cat)[i].lctaddr = (*cat)[i].lctlen = 0; */
  /*     (*cat)[i].lctnom  = (*cat)[i].lctform = 0; */
  /*     memcpy(&(*cat)[i].lcttype,&buf[i*24   ], 1); */
  /*     memset((*cat)[i].lctname,' ',24); */
  /*     memcpy( (*cat)[i].lctname,&buf[i*24+ 1],13); */
  /*     memcpy(&(*cat)[i].lctnom ,&buf[i*24+14], 1); */
  /*     memcpy(&(*cat)[i].lctaddr,&buf[i*24+15], 4); */
  /*     memcpy(&(*cat)[i].lctlen ,&buf[i*24+19], 4); */
  /*     memcpy(&(*cat)[i].lctform,&buf[i*24+23], 1); */
  /*     hcat->catfaddr += (*cat)[i].lctlen; */
  /*     //      printf("read_mcat, faddr=%ld\n", hf->faddr); */
  /*     //if ((*cat)[i].lcttype == T_CATEXT)  */
  /*     { */
  /*       char name[14]; */
  /*       strncpy(name, (*cat)[i].lctname, 23); */
  /*       name[23] = 0x00; */
  /* 	//	printf("%d <%s> %d %ld %d\n",i,name,(*cat)[i].lctnom,(*cat)[i].lctlen,(*cat)[i].lctform);  */
  /*     } */
  /*   } */
  /*   b += hcat->catmlen*24; */
  /*   ib = ie; */
  /* } */
  /* free(buf); */
  return 0;
} /* read_mcat */

int read_mcat2(MCAT* cat, HF* hf)
{
  char *buf, *b, *pb;
  HCAT *hcat;
  int i, n, ko, ib, ie, ind, lcatt, jj;
  size_t lwr, lencat, faddr;
  hcat=hf->hcatptr;
  lencat = hcat->catmlen*(hcat->nexts+1);
  //printf("rlen %d mlen %d nexts %d\n",hcat->catrlen,hcat->catmlen,hcat->nexts); 
  lcatt = hcat->catmlen*sizeof(CAT)*(hcat->nexts+1);
  //printf("@@read_mcat2 lcatt=%z\n", lcatt);
  buf = b = pb = (char*)malloc(lcatt);
  //printf("read_mcat len buf=%d ext=%d\n",lcatt,hcat->nexts);
  ib = 0;
  hcat->catfaddr = 16;
  for (n = 0; n <= hcat->nexts; n++) {
    //printf("### n=%d ind=%d nexts=%d\n", n, ind, hcat->nexts);
    if (n > 0) {
      ind = FindInCat(cat,(hcat->catrlen),"## Extent ## ",T_CATEXT,n,hf->ver2);
      if (ind < 0) { 
 	printf("@@ read_mcat2 ext=%d\n",n); 
        printf("#### Error in mcat,  %d items\n", n);
        hf->lencat = hcat->catrlen = n;
	ko=MSFOP5; mistake(ko,m9); return ko;
      }
      faddr = (*cat)[ind].lctaddr;
      //printf("@@ read_mcat1 ext=%d seek %d %zd\n",n,ind,faddr);  
      fseek(hf->filptr,faddr,SEEK_SET);
    }
    //printf("### n=%d ind=%d\n", n, ind);
    //printf("read_mcat buf=%04x\n",buf); 
    lwr = min(hcat->catmlen,lencat)*sizeof(CAT);
    hcat->catfaddr += lwr;
    //printf("-- read_mcat2 e, faddr=%ld\n", hcat->catfaddr);
    if (Fread(b,1,lwr,hf->filptr) != lwr) {
/*       printf("read_mcat: n %d read %d wonted %d lencat=%d\n",n, i,lwr,lencat); */
      ko = MSFOP3; mistake(ko,m7); return ko;
    }
    ie = ib + hcat->catmlen;
    lencat -= hcat->catmlen;
    //printf("read_mcat i=%d %d\n",ib,ie); 
    if (ie > hcat->catrlen) ie = hcat->catrlen;
    for (i = ib; i < ie; i++) {
      /* printf("@@ "); */
      /* for (jj = 0; jj < 48; jj++) { */
      /* 	printf("%02hhx ", pb[jj]); */
      /* 	if (jj % 24 == 23) printf("\n@@ "); */
      /* } */
      memcpy(&(*cat)[i].lcttype, pb, sizeof(sioLctType));  pb += sizeof(sioLctType);
      memcpy(&(*cat)[i].lctname, pb, sizeof(sioLctName));  pb += sizeof(sioLctName);
      memcpy(&(*cat)[i].lctaddr, pb, sizeof(sioLctFaddr)); pb += sizeof(sioLctFaddr);
      memcpy(&(*cat)[i].lctlen , pb, sizeof(sioLctFaddr)); pb += sizeof(sioLctFaddr);
      memcpy(&(*cat)[i].lctform, pb, sizeof(sioLctForm));  pb += sizeof(sioLctForm);
      memcpy(&(*cat)[i].lctnom , pb, sizeof(sioLctNom ));  pb += sizeof(sioLctNom );
      if ((*cat)[i].lcttype == T_RECNAME) hcat->catfaddr += (*cat)[i].lctlen;
      if ((*cat)[i].lcttype == T_ARRDEF)  hcat->catfaddr += (*cat)[i].lctlen;
      /* printf("@@ %d: %02x %24s %d %zd %d %zd\n",  */
      /* 	     i,  */
      /* 	     (*cat)[i].lcttype,  */
      /* 	     (*cat)[i].lctname,  */
      /* 	     (*cat)[i].lctnom,  */
      /* 	     (*cat)[i].lctlen,  */
      /* 	     (*cat)[i].lctform,  */
      /* 	     (*cat)[i].lctaddr);  */
      /* printf("@@ read_mcat2 %d , delta=%zd faddr=%zd\n", i, pb-buf, hcat->catfaddr); */
    }
    b += hcat->catmlen*sizeof(CAT);
    ib = ie;
  }
  free(buf);
  return 0;
} /* read_mcat2 */



/* ===========================================================  сброс HCAT */
int write_hcat(HCAT* hcat, HF* hf)
{
  char *buf;
  int ko;
  buf = (char*)malloc(16);
  memcpy(&buf[0] ,&hcat->catver2,1);
  memcpy(&buf[1] ,&hcat->catmlen,2);
  memcpy(&buf[3] ,&hcat->catrlen,2);
  memcpy(&buf[5] ,&hcat->catdelkey_,2);
  memcpy(&buf[7] ,&hcat->catfaddr,4);
  memcpy(&buf[11],&hcat->nexts,2);
  buf[13] = hcat->date_y;
  buf[14] = hcat->date_m;
  buf[15] = hcat->date_d;
  if (fwrite(buf,1,16,hf->filptr) != 16) {
    ko = MSFCL2; mistake(ko,m12); return ko;
  }
  free(buf);
  return 0;
} /* write_hcat */
				/* in pack */



/* ===========================================================  сброс MCAT */
int write_mcat(MCAT* cat, HF* hf)
{
  char *buf, *pbuf;
  HCAT *hcat;
  int i, ko, ind, lbuf, lwr;
  size_t faddr;
  hcat=hf->hcatptr;
  printf("write_mcat not emplemented\n");
  exit(-1);
/*   lbuf = max(hcat->catrlen*24,hcat->catmlen*24); */
/*   lbuf = hcat->catmlen*24*(hcat->nexts+1); */
/*   buf = pbuf = (char*)malloc(lbuf); */
/*   memset (buf, 0x00, lbuf); */
/*   for (i = 0; i < hcat->catrlen; i++) { */
/*     memcpy(&buf[i*24   ],&(*cat)[i].lcttype, 1); */
/*     memcpy(&buf[i*24+ 1], (*cat)[i].lctname,13); */
/*     memcpy(&buf[i*24+14],&(*cat)[i].lctnom , 1); */
/*     memcpy(&buf[i*24+15],&(*cat)[i].lctaddr, 4); */
/*     memcpy(&buf[i*24+19],&(*cat)[i].lctlen , 4); */
/*     memcpy(&buf[i*24+23],&(*cat)[i].lctform, 1); */
/*   } */
/* /\*   printf("write_mcat nexts=%d rlen=%d\n",hcat->nexts,hcat->catrlen);  *\/ */
/*   for (i = 0; i <= hcat->nexts; i++) { */
/*     if (i > 0) { */
/*       ind = FindInCat(cat,(hcat->catrlen),"## Extent ## ",T_CATEXT,i,hf->ver2); */
/*       if (ind < 0) { ko=MSFOP5; mistake(ko,m9); return ko; } */
/*       faddr = (*cat)[ind].lctaddr; */
/* /\*       printf("write_mcat ext=%d seek %d %d\n",i,ind,faddr);  *\/ */
/*       fseek(hf->filptr,faddr,SEEK_SET); */
/*     } */
/*     lwr = min(hcat->catmlen*24,lbuf); */
/* /\*     printf("write_mcat len=%d %d\n",hcat->catmlen*24,lwr);  *\/ */
/*     if (fwrite(buf,1,lwr,hf->filptr) != lwr) { */
/*       ko = MSFCL2; mistake(ko,m13); return ko; */
/*     } */
/*     buf += hcat->catmlen*24; */
/*     lbuf -= hcat->catmlen*24; */
/*   } */
/*   free(pbuf); */
  return 0;
} /* write_mcat */
				/* in pack */
int write_mcat2(MCAT* cat, HF* hf)
{
  char *buf, *buf0, *pbuf;
  HCAT *hcat;
  int i, ko, ind, jj;
  size_t lbuf, lwr;
  size_t faddr;
  //  printf("sizeof cat2          = %d\n", sizeof(CAT));
  //  printf("sizeof cat2->lcttype = %d\n", sizeof(cat_s.lcttype));
  //  printf("sizeof cat2->lctname = %d\n", sizeof(cat_s.lctname));
  //  printf("sizeof cat2->lctaddr = %d\n", sizeof(cat_s.lctaddr));
  //  printf("sizeof cat2->lctlen  = %d\n", sizeof(cat_s.lctlen));
  //  printf("sizeof cat2->lctform = %d\n", sizeof(cat_s.lctform));
  //  printf("sizeof cat2->lctnom  = %d\n", sizeof(cat_s.lctnom));
  hcat=hf->hcatptr;
/*   lbuf = max(hcat->catrlen*24,hcat->catmlen*24); */
  lbuf = hcat->catmlen*sizeof(CAT)*(hcat->nexts+1);
  buf = buf0 = pbuf = (char*)malloc(lbuf);
  //printf("@@ write_mcat2 lbuf=%zd\n", lbuf);
  memset (buf, 0x00, lbuf);
  for (i = 0; i < hcat->catrlen; i++) {
    memcpy(pbuf, &(*cat)[i].lcttype, sizeof(sioLctType )); pbuf += sizeof(sioLctType);
    memcpy(pbuf, &(*cat)[i].lctname, sizeof(sioLctName )); pbuf += sizeof(sioLctName);
    memcpy(pbuf, &(*cat)[i].lctaddr, sizeof(sioLctFaddr)); pbuf += sizeof(sioLctFaddr);
    memcpy(pbuf, &(*cat)[i].lctlen , sizeof(sioLctFaddr)); pbuf += sizeof(sioLctFaddr);
    memcpy(pbuf, &(*cat)[i].lctform, sizeof(sioLctForm )); pbuf += sizeof(sioLctForm);
    memcpy(pbuf, &(*cat)[i].lctnom , sizeof(sioLctNom  )); pbuf += sizeof(sioLctNom );
    //printf("delta=%zd\n", pbuf - buf0);
  }
/*   printf("write_mcat nexts=%d rlen=%d\n",hcat->nexts,hcat->catrlen);  */
  buf = buf0;
  for (i = 0; i <= hcat->nexts; i++) {
    if (i > 0) {
      ind = FindInCat(cat,(hcat->catrlen),"## Extent ## ",T_CATEXT,i,hf->ver2);
      if (ind < 0) { ko=MSFOP5; mistake(ko,m9); return ko; }
      faddr = (*cat)[ind].lctaddr;
      //printf("@@ write_mcat1 ext=%d ind=%d seek %zd\n",i,ind,faddr);  
      fseek(hf->filptr,faddr,SEEK_SET);
    }
    lwr = min(hcat->catmlen*sizeof(CAT),lbuf);
    //printf("@@ write_mcat2 ext=%d len=%zd %zd\n",i, hcat->catmlen*sizeof(CAT),lwr);  
    if (fwrite(buf,1,lwr,hf->filptr) != lwr) {
      ko = MSFCL2; mistake(ko,m13); return ko;
    }
    /* // проверка записываемой информации */
    /* pbuf = buf; */
    /* printf("@@ "); */
    /* for (jj = 0; jj < lwr; jj++) { */
    /*   printf("%02hhx ", pbuf[jj]); */
    /*   if (jj % 24 == 23) printf("\n@@ "); */
    /* } */
    /* // конец проверки */
    buf += hcat->catmlen*sizeof(CAT);
    lbuf -= hcat->catmlen*sizeof(CAT);
  }
  free(buf0);
  return 0;
} /* write_mcat2 */
				/* in pack */


int FindInCat(MCAT* cat, int lcatt, const char* namep, int type, int nom, int ver2)
{
  int ind,
    ko,
    l;
  static char name[24], namec[24];
  char *b;
  int lenname = (ver2 ? 23 : 13);
  l=strlen(namep); if (l>lenname) l=lenname;
  strcpy (name,empty_name); strncpy(name,namep,l);
  //printf("find name='%s' l=%d\n", name, l);
  for (ind=0; ind<lcatt; ind++) {
    b=(*cat)[ind].lctname;
    l=strlen(b); if (l>lenname) l=lenname;
    strcpy (namec,empty_name); strncpy(namec,b,l);
    //printf("@@ FindInCat-1 cmp '%s' '%s' r=%d\n", name, namec, strcmp(name,namec));
    if (strcmp(name,namec) == 0 && (*cat)[ind].lcttype == type) {
      //if ((*cat)[ind].lcttype == type) printf("@@ FindInCat-2 cmp %s t=%d nom=%d %d\n", 
      //                                        name, type, (*cat)[ind].lctnom, nom); 
      if ((*cat)[ind].lcttype == type && (*cat)[ind].lctnom == nom) {
	//printf("@@ cmp '%s' '%s' nom=%d ind=%d\n", name, namec, nom, ind);
	return ind;
      }
      if ((*cat)[ind].lcttype == type && nom == -1) {
	//printf("cmp '%s' '%s' nom=%d ind=%d\n", name, namec, nom, ind);
	return ind; /* для массивов */
      }
      else if (nom == 0) {
        mistake((*cat)[ind].lcttype,m17);
        ko=MSRWR1; return ko;
      }
    }
  }
  return -1;
} /* FindInCat */



int InsertInCat(HF** hf, 
		 const char* namep,
		 int type,
		 size_t lenb,
		 int form)
{
  static char name[24];
  int l;
  int ind, ko;
  size_t addr;
  HCAT *hcat;
  MCAT *cat, *catext;
  int lcatt, lcattold, lenc;
  int lenname = ((*hf)->ver2 ? 23 : 13);
  //printf("InsertInCat name=%s type=%d lenb=%ld form=%d\n", namep, type, lenb, form);
  cat=  (*hf)->catptr;
  hcat= (*hf)->hcatptr;
  if ((*hf)->lencat >= hcat->catmlen*(hcat->nexts+1)-1) {
// расширение каталога
    lcattold = sizeof(CAT)*(hcat->catmlen * (hcat->nexts+1));
    hcat->nexts ++;
    lcatt    = sizeof(CAT)*(hcat->catmlen * (hcat->nexts+1));
    catext = (MCAT*)malloc(lcatt);
    //printf("## InsertInCat Extent cat #=%d lold=%d lnew=%d catext=%p catmlen=%d\n",
    //	   hcat->nexts+1, lcattold,lcatt, catext, hcat->catmlen);
    if (catext == 0) {
      printf("## Bad mem for catetx\n");
      exit(-1);
    }
    //printf("##A1 %p %p %ld\n", catext,cat,lcattold);
    memcpy(catext,cat,lcattold);
    //printf("##A2\n");
/*     puts("copy"); */
    free(cat);
    //printf("##A3\n");
    (*hf)->catptr = catext;
    //printf("##A4\n");
    cat=  (*hf)->catptr;
    //printf("##A5\n");
    ind=(*hf)->lencat; (*hf)->lencat++;
    //printf("## cat=%p ind=%d lencat=%d\n", cat, ind, (*hf)->lencat);
    addr=(*hf)->faddr;
    lenc = sizeof(struct cat)*(hcat->catmlen);
    (*cat)[ind].lcttype=T_CATEXT;
    strcpy((*cat)[ind].lctname,"## Extent ##           ");
    (*cat)[ind].lctnom = hcat->nexts;
    (*cat)[ind].lctlen =lenc;
    (*cat)[ind].lctform=0;
    (*cat)[ind].lctaddr=addr;
    //printf("#3-faddr = %ld %ld\n", (*hf)->faddr, lenc);
    (*hf)->faddr += lenc;
    //printf("#3 faddr = %ld %ld\n", (*hf)->faddr, lenc);
    //printf("InsertInCat insert extend, faddr=%ld lenc=%d sizecat=%d catmlen=%d\n",
    //	   (*hf)->faddr, lenc,  sizeof(struct cat), hcat->catmlen);
  }
  addr=(*hf)->faddr;
  ind=(*hf)->lencat; (*hf)->lencat++;
  l=strlen(namep); if (l>lenname) l=lenname;
  strcpy (name,empty_name); strncpy(name,namep,l);
  //printf("InsertInCat insert name=%s l=%d\n", name, l);
  (*cat)[ind].lcttype=type;
  strcpy((*cat)[ind].lctname,name);

  if (type != T_POLNAME && type != T_ARRDIM) {
    (*cat)[ind].lctaddr=addr;
    addr=(*hf)->faddr;
    (*hf)->faddr += lenb;
    //printf("#4 faddr = %ld %ld\n", (*hf)->faddr, lenb);
    //printf("insertincat faddr=%ld added %ld\n", (*hf)->faddr, lenb);
  } else {
    (*cat)[ind].lctaddr=0;
  }
  (*cat)[ind].lctlen =lenb;
  (*cat)[ind].lctform=form;

  //printf("Insertincat insert ind=%d %d %s %d a=%d l=%d faddr=%ld\n", ind, (*cat)[ind].lcttype, namep, (*cat)[ind].lctnom, (*cat)[ind].lctaddr, (*cat)[ind].lctlen, (*hf)->faddr);
  return ind;
} /* InsertInCat */



